/*
 *  A Win32 UDP flooding utility for penetration testing
 *  Icon design by shojomangarox
 *  Copyright (C) 2010  unixunited@live.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef UDPUNICORN_H
#define UDPUNICORN_H

#define DEBUG
#undef DEBUG // remove for debugging

#define STRICT
#define _WIN32_IE     0x501
#define _WIN32_WINNT  0x501
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <commctrl.h>
#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <ctype.h>
#include <time.h>

#include "resource.h"

#define RAND_PORT 777
#define RAND_SIZE 666

//------------------------------

// structures required to use functions in ICMP.DLL
typedef struct {
    unsigned char Ttl;                         // Time To Live
    unsigned char Tos;                         // Type Of Service
    unsigned char Flags;                       // IP header flags
    unsigned char OptionsSize;                 // Size in bytes of options data
    unsigned char *OptionsData;                // Pointer to options data
} IP_OPTION_INFORMATION, *PIP_OPTION_INFORMATION;

typedef struct {
    DWORD Address;                             // Replying address
    unsigned long  Status;                     // Reply status
    unsigned long  RoundTripTime;              // RTT in milliseconds
    unsigned short DataSize;                   // Echo data size
    unsigned short Reserved;                   // Reserved for system use
    void *Data;                                // Pointer to the echo data
    IP_OPTION_INFORMATION Options;             // Reply options
} IP_ECHO_REPLY, *PIP_ECHO_REPLY;

typedef struct ip {
   unsigned int   ip_hl; /* both fields are 4 bits */
   unsigned int   ip_v;
   uint8_t        ip_tos;
   uint16_t       ip_len;
   uint16_t       ip_id;
   uint16_t       ip_off;
   uint8_t        ip_ttl;
   uint8_t        ip_p;
   uint16_t       ip_sum;
   struct in_addr ip_src;
   struct in_addr ip_dst;
} IP_HDR, *PIP_HDR;

typedef struct udphdr {
    u_short uh_sport; /* src port */
    u_short uh_dport; /* dst port */
    short uh_ulen; /* udp length */
    u_short uh_sum; /* checksum */
} UDP_HDR, *PUDP_HDR;


// structure to hold target data
typedef struct data_t
{
    char ip[256];
    char src_ip[256];
    unsigned int port;
    size_t size;
    unsigned int delay;
    unsigned int timeout;
    unsigned int sockets;
} DATA, *PDATA;

//------------------------------

void test_target(HWND hwnd);

void reverse_dns(HWND hwnd);

void setup_attack(HWND hwnd);

DWORD WINAPI _test_target(LPVOID lpBuffer);

DWORD WINAPI _reverse_dns(LPVOID lpBuffer);

DWORD WINAPI _attack(LPVOID lpBuffer);

/*
DWORD WINAPI _forged_attack(LPVOID lpBuffer);

unsigned short checksum(unsigned short *buf, int nWords);
*/

#endif
